package fxMMKurssit;

import fi.jyu.mit.fxgui.ModalController;

import java.net.URL;
import java.util.List;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.CheckBoxChooser;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.stage.Stage;
import mmkurssit.Kurssi;
import mmkurssit.MMKurssit;
import mmkurssit.SailoException;
import mmkurssit.Tapaaminen;


/**
 * @author aichi
 * @version 5.2.2025
 *
 */
public class MMKurssitGUIController implements Initializable {
    
    
//=============================================================================
    
    /**
     * Avataan ensin ohjelman käynistysikkuna (ennen avaa pääikkunaa)
     * @return false jos painetaan cancel Ohjelman käynistysikkunalla
     */
    public boolean avaa() {
        
        ModalController.showModal(OhjelmankaynistysGUIController.class.getResource("OhjelmankaynistysGUIView.fxml"), 
                "Missä & Milloin Kurssit", null, "");
        
        return true;
    }

//Attribuutit===================================================================

    @FXML    private ListChooser<Kurssi> allCourses;

    @FXML    private Button buttonAddMeeting;
    @FXML    private Button buttonOpenMeeting;

    @FXML    private CheckBox onlyUpcoming;

    @FXML    private Label sectionTitle;

    @FXML    private CheckBoxChooser<Kurssi> selectedCourse;

    @FXML    private ListChooser<Tapaaminen> tapaamiset;

    @FXML    private TextField textSearch;

   //===============================================
    
    private MMKurssit mmkurssit;
    
//==============================================================================   

    @FXML  void addMeeting() {
        
        addTapaaminen();
        
        /*ModalController.showModal(LisaaTapaaminenGUIController.class.getResource("LisaaTapaaminenGUIView.fxml"), 
                "Missä ja Milloin Kurssi", null, "");*/
      }


    //TapaaminenTiedot jotain outo? Ei toimi sen takia, että renamed afterwards?
    @FXML    void openMeetingInfo() {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("TapaaminenTiedotGUIView.fxml"));
            Parent root2 = (Parent) fxmlLoader.load();//tiedostossa jotain vika?
            Stage stage = new Stage();
            stage.setScene(new Scene(root2));
            stage.show();
        } catch(Exception e) {
            System.err.println(e.getMessage());
        }
    }
        
    
    @FXML    void addCourse() {
        /*ModalController.showModal(KurssinlisaysGUIController.class.getResource("KurssinlisaysGUIView.fxml"), 
                "Missä ja Milloin Kurssi", null, "");*/
        addKurssi();
    }
    


    @FXML   void openCourseList() {
        //
    }
    
    
    /**
     * Uncheck all the selected courses
     */
    @FXML    void resetSelected() {
        //
    }
    
    
    /**
     * If a user check this checkbox, show only the upcoming meetings on the list
     */
    @FXML    void showUpcomingMeetingsOnly() {
        //
    }
    
    
    @FXML   void refreshWindow() {
        //
    }
    
    @FXML    void closeProgram() {
        Platform.exit();
    }
//===================================================================================

    /**
     * Asetetaan käytettävä mmkurssit (aktivoitu MMKurssitMain:lla)
     * @param mmkurssit jota käytetään
     */
    public void setMMKurssit(MMKurssit mmkurssit) {
        this.mmkurssit = mmkurssit;        
    }
    
    
    @Override
    public void initialize(URL arg0, ResourceBundle arg1) {
        alusta();   
    }
    
    //=========
    
    private void alusta() {
        allCourses.clear();
        tapaamiset.clear();
    }
    
    /**
     * Lisätään mmkurssille uusi kurssi
     */
    private void addKurssi() {
        Kurssi uusi = new Kurssi();
        uusi.rekisteroi();
        uusi.tayta();
        
        try {
            mmkurssit.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden kurssin luomisessa" + e.getMessage());
        }
        haeKurssi(uusi.getID());
    }

    
    /**
     * Haetaan kurssia
     * @param nro kurssin ID, joka valitaan
     */
    private void haeKurssi(int nro) {
        allCourses.clear();
        
        int indeksi = 0;
        for (int i= 0; i<mmkurssit.getKurssienKpl(); i++) { //käydään läpi kaikki kurssit
            Kurssi k = mmkurssit.annaKurssi(i);             //otetaan 1 kurssi kerrallaan
            if (k.getID() == nro) indeksi = i;              
            allCourses.add(""+k.getNimi(), k);
        }
        allCourses.setSelectedIndex(indeksi);
    }
    
    
    private void addTapaaminen() {
        Tapaaminen tap = new Tapaaminen();//väkisin nyt kaikki tapaamisien kurssiID on 1, myöhemmin korjattava!
        tap.rekisteroi();
        tap.tayta();
        
        mmkurssit.lisaa(tap);
        
        haeTapaaminen(tap);
}


    private void haeTapaaminen(Tapaaminen tap) {
        tapaamiset.clear();//laitetaan tyhjäksi eka
        
        int kurssiID = tap.getkID();
        List<Tapaaminen> lista1 = mmkurssit.annaTapaamiset(kurssiID);//saadaan lista, jossa on kaikki tapaamiset, jotka liittyy samaan kurssiin
        
        int indeksi = 0;
        for (int i=0; i<lista1.size(); i++) {
            Tapaaminen t = lista1.get(i);
            indeksi = i;
            tapaamiset.add(""+t.getRadNro()+" "+t.milloin()+" "+t.aloitusaika(), t);
        }
        tapaamiset.setSelectedIndex(indeksi);
    }

    


    
    
      
}