package mmkurssit;

//import java.io.OutputStream;
//import apumetodit.RandomNumero;
import fi.jyu.mit.ohj2.Mjonot;

import java.io.PrintStream;

import apumetodit.RandomNumero;

/**
 * - kopioi CRC-kortin vastuut tähän
 * @author aichinos
 * @version 25 Feb 2025
 *
 */
public class Kurssi {

    private int kurssiID = 0;
    private String nimi = "";
    private String opeSukunimi = "";
    private String opeEtunimi = "";
    
    private static int nextID = 1; // static = riippumatta olion olemassa olosta, atribuutti syntyy
                                        //          kun ohjelma käynistyy
                                        //        = yhteinen attribuutti koko luokassa
//=========================================================    
    
    /**
     * Kurssin alustuts
     */
    public Kurssi() {
        //
    }
    
    
    /**
     * TODO myöhemmin: ota käyttöön!
     * 
     * Tulostetaan kurssin tiedot
     * @param os teitovirta johon tulostetaan 
     */
    //public void tulosta(OutputStream os) {
    //    //tulsota(new PrintStream(os));
    //}
    
    
    /**
     * Tulostetaan kurssin tiedot
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        out.println(String.format("Course ID: %03d", kurssiID) + " " + nimi);
                        //"%03d" = aina vähintään 3 numeroa, jos se ei täytä 3 numeroa niin 0:lla täytä
                        // sama tulostuu ("Course ID: ") + String.format("%03d", kurssiID)+ ---
        out.println(openNimet());
    }
    
    
    /**
     * Palauttaa kurssin ID
     * @return kurssin tunnusnumero
     */
    public int getID() {
        return this.kurssiID;
    }
    
    
    /**
     * Antaa kurssille seuraavan tunnusnumeron
     * @example
     * <pre name="test">
     *    Kurssi saksa = new Kurssi();
     *      saksa.getID() === 0;
     *      saksa.rekisteroi();
     *    Kurssi ohjelmointi = new Kurssi();
     *      ohjelmointi.rekisteroi();
     *    int n1 = saksa.getID();
     *    int n2 = ohjelmointi.getID();
     *    n2 === n1+1;
     * </pre>
     */
    public void rekisteroi() {
        this.setID(nextID);
        // = { this.kurssiID = nextID; nextID++; }
    }
    
    
    /**
     * Asettaa kurssin ID ja samalla varmista, että 
     * seuraava numero on aina suurempi kuin tähän mennessä suurin.
     * @param nro asetettava kurssi ID
     */
    public void setID(int nro) {  // TODO: ristiriita rekisteroi()-metodin kanssa??????
        this.kurssiID = nro;
        if (this.kurssiID >= nextID) nextID = this.kurssiID+1;
    }
    
    
    /**
     * @return kurssin nimi
     */
    public String getNimi() {
        return this.nimi;
    }
    
    
    /**
     * @return kurssin opettajan sukunimi + etunimi
     */
    public String openNimet() {
        return this.opeSukunimi + " " + this.opeEtunimi;
    }
    
    
    /**
     * Apumetodi, jolla saadaan täytettyä testiarvot kurssille.
     * TODO: POISTA, kun kaikki toimii!!
     * 
     */
    public void tayta() {
        this.nimi = "Esimerkkikurssi"+ RandomNumero.rand(1,100); //+ RandomNumero.rand(1,100);
        this.opeEtunimi = "Vesa";
        this.opeSukunimi = "Kokko";
        
    }
    
    
    /**
     * Tilanne: 11.3. yritin luennon videon kanssa yritin tehdä 
     *   tiedoston tallentaminen, lukeminen, Kurssi.toString() metodi, parse(), setID()
     *   --ei toimi. Ennen sitä testi oli ok.
     *   
     * !!HUOM
     *     Tämä metodi tarvitsee parantaa, nyt ei ole hyvin käyttökelpoinen.
     *     toString-metodin testaamista varten tehty
     * syötetään kurssi-oiliolle tiedot
     * @param rivi tiedot string-muotona
     */
    public void parse(String rivi) {
        
        StringBuilder sb = new StringBuilder(rivi);
        setID(Mjonot.erota(sb, '|', getID()));
        nimi = Mjonot.erota(sb, '|', nimi);
        opeSukunimi = Mjonot.erota(sb, '|', opeSukunimi);
        opeEtunimi = Mjonot.erota(sb, '|', opeEtunimi);
    }
    

    /**
     * TODO ??? Testi ei mene läpi, Kurssi-olion alustaminen ei onnistu ????
     * 
     * Palauttaa kurssin tiedot Stringina, jonka voi tallentaa tiedostoon
     * @return kurssin tiedot String-muotona
     * @example
     *  <pre name="test">
     *     Kurssi hollanti = new Kurssi();
     *     hollanti.parse("1|Esimerkkikurssi|Kokko |Vesa");
     *     hollanti.toString() === "1|Esimerkkikurssi|Kokko Vesa";
     *  </pre>
     */
    @Override
    public String toString() {
        
        return ""+
               this.getID()+"|"+
               this.nimi+"|"+
               this.openNimet();
        
        //TODO myöhemmin mieti: voisi olla suku + etu, kumpi olisi parempi muoto tallentaa jatkossa       
    }
    
    
    //MAIN========================================================
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
    // luento 24.2.2025
    // Käytetään fxMMKurssi-mainissa oleva main koko ohjelmaa varten, mutta Java sallii,
    //että ohjelman sisällä tavallaan monta main-methodia.
        System.out.println(nextID);
        System.out.println("--------------");
        
        Kurssi ohjelmointi1 = new Kurssi();
        ohjelmointi1.rekisteroi();
        ohjelmointi1.tulosta(System.out);//tulostetaan ilman mitään täytetty tietoa
       
        ohjelmointi1.tayta();
        ohjelmointi1.tulosta(System.out);
        
        System.out.println("-------------------");
        
        Kurssi ohjelmointi2 = new Kurssi();
        ohjelmointi2.rekisteroi();
        ohjelmointi2.tulosta(System.out);
        
        ohjelmointi2.tayta();
        ohjelmointi2.tulosta(System.out);
        
        System.out.println("NextID on: " + nextID);
    }

    
    


    

}
